summaryrefslogtreecommitdiff
path: root/src/monkeysphere-host
diff options
context:
space:
mode:
authorMatt Goins <mjgoins@openflows.com>2009-02-09 21:54:58 -0500
committerMatt Goins <mjgoins@openflows.com>2009-02-09 21:54:58 -0500
commit3b81cd012e8224490a3836cccbd7d082a061658e (patch)
tree71fa874a6a98680388ff7a8b1a6e478390bd5b1d /src/monkeysphere-host
parentc9a361eecab5ea18d0b868580a3d0703517ab677 (diff)
parentd71cf8d24bd9357a016b1ead375a67ccd955c130 (diff)
Merge commit 'jrollins/master'
Diffstat (limited to 'src/monkeysphere-host')
-rwxr-xr-xsrc/monkeysphere-host137
1 files changed, 88 insertions, 49 deletions
diff --git a/src/monkeysphere-host b/src/monkeysphere-host
index a6fa62f..be398b1 100755
--- a/src/monkeysphere-host
+++ b/src/monkeysphere-host
@@ -14,6 +14,9 @@
########################################################################
set -e
+# set the pipefail option so pipelines fail on first command failure
+set -o pipefail
+
PGRM=$(basename $0)
SYSSHAREDIR=${MONKEYSPHERE_SYSSHAREDIR:-"/usr/share/monkeysphere"}
@@ -65,70 +68,98 @@ subcommands:
EOF
}
-# function to run command as monkeysphere user
-su_monkeysphere_user() {
- # if the current user is the monkeysphere user, then just eval
- # command
- if [ $(id -un) = "$MONKEYSPHERE_USER" ] ; then
- eval "$@"
+# function to interact with the gpg keyring
+gpg_host() {
+ GNUPGHOME="$GNUPGHOME_HOST" gpg "$@"
+}
+
+# command to list the info about the host key, in colon format
+gpg_host_list() {
+ gpg_host --list-keys --with-colons --fixed-list-mode \
+ --with-fingerprint --with-fingerprint \
+ "0x${HOST_FINGERPRINT}!"
- # otherwise su command as monkeysphere user
- else
- su "$MONKEYSPHERE_USER" -c "$@"
- fi
}
-# function to interact with the gpg keyring
-gpg_host() {
- local returnCode
+# command for edit key scripts, takes scripts on stdin
+gpg_host_edit() {
+ gpg_host --quiet --command-fd 0 --edit-key \
+ "0x${HOST_FINGERPRINT}!" "$@"
+}
- GNUPGHOME="$GNUPGHOME_HOST"
- export GNUPGHOME
+# export the host key to stdout
+gpg_host_export() {
+ gpg_host --export --armor --export-options export-minimal \
+ "0x${HOST_FINGERPRINT}!"
+}
- # NOTE: we supress this warning because we need the monkeysphere
- # user to be able to read the host pubring. we realize this might
- # be problematic, but it's the simplest solution, without too much
- # loss of security.
- gpg "$@"
+# export the host key to the monkeysphere host file key
+gpg_host_export_to_ssh_file() {
+ log debug "exporting openpgp public key..."
+
+ gpg_host_export > "$HOST_KEY_PUB_GPG"
+ log info "SSH host public key in OpenPGP form: $HOST_KEY_PUB_GPG"
}
# output just key fingerprint
-fingerprint_host_key() {
- # set the pipefail option so functions fails if can't read sec key
- set -o pipefail
-
+# FIXME: should not have to be priviledged user to get host
+# fingerprint. should be taken from publicly accessible key files,
+# instead of the keyring.
+get_host_fingerprint() {
gpg_host --list-secret-keys --fingerprint \
--with-colons --fixed-list-mode 2> /dev/null | \
- grep '^fpr:' | head -1 | cut -d: -f10 2>/dev/null
+ grep '^fpr:' | head -1 | cut -d: -f10 2>/dev/null || true
+}
+
+# output the index of a user ID on the host key
+# return 1 if user ID not found
+find_host_userid() {
+ local userID="$1"
+ local tmpuidMatch
+ local line
+
+ # match to only ultimately trusted user IDs
+ tmpuidMatch="u:$(echo $userID | gpg_escape)"
+
+ # find the index of the requsted user ID
+ # NOTE: this is based on circumstantial evidence that the order of
+ # this output is the appropriate index
+ line=$(gpg_host_list | egrep '^(uid|uat):' | cut -f2,10 -d: | \
+ grep -n -x -F "$tmpuidMatch" 2>/dev/null)
+
+ if [ "$line" ] ; then
+ echo ${line%%:*}
+ return 0
+ else
+ return 1
+ fi
}
# function to check for host secret key
-check_host_keyring() {
- fingerprint_host_key >/dev/null \
- || failure "You don't appear to have a Monkeysphere host key on this server. Please run 'monkeysphere-host import-key' first."
+check_host_fail() {
+ [ "$HOST_FINGERPRINT" ] || \
+ failure "You don't appear to have a Monkeysphere host key on this server. Please run 'monkeysphere-host expert import-key' first."
}
# show info about the host key
show_key() {
- local fingerprintPGP
local fingerprintSSH
- # FIXME: you shouldn't have to be root to see the host key fingerprint
- check_host_keyring
- fingerprintPGP=$(fingerprint_host_key)
+ gpg_host --fingerprint --list-key --list-options show-unusable-uids \
+ "0x${HOST_FINGERPRINT}!" 2>/dev/null
+ # FIXME: make sure expiration date is shown
- gpg_host --fingerprint --list-key --list-options show-unusable-uids "0x${fingerprintPGP}!" 2>/dev/null
- echo "OpenPGP fingerprint: $fingerprintPGP"
+ echo "OpenPGP fingerprint: $HOST_FINGERPRINT"
- if [ -f "${MHDATADIR}/ssh_host_rsa_key.pub" ] ; then
- fingerprintSSH=$(ssh-keygen -l -f "${MHDATADIR}/ssh_host_rsa_key.pub" | \
+ if [ -f "$HOST_KEY_PUB" ] ; then
+ fingerprintSSH=$(ssh-keygen -l -f "$HOST_KEY_PUB" | \
awk '{ print $1, $2, $4 }')
+
echo "ssh fingerprint: $fingerprintSSH"
else
- log info "SSH host key not found."
+ log error "SSH host key not found."
fi
- # FIXME: show expiration date
# FIXME: other relevant key parameters?
}
@@ -155,6 +186,13 @@ MONKEYSPHERE_USER=${MONKEYSPHERE_MONKEYSPHERE_USER:=${MONKEYSPHERE_USER:="monkey
CHECK_KEYSERVER=${MONKEYSPHERE_CHECK_KEYSERVER:="true"}
GNUPGHOME_HOST=${MONKEYSPHERE_GNUPGHOME_HOST:="${MHDATADIR}"}
+# host key fingerprint
+HOST_FINGERPRINT=$(get_host_fingerprint)
+
+# host pub key files
+HOST_KEY_PUB="${SYSDATADIR}/ssh_host_rsa_key.pub"
+HOST_KEY_PUB_GPG="${SYSDATADIR}/ssh_host_rsa_key.pub.gpg"
+
# export variables needed in su invocation
export DATE
export MODE
@@ -163,56 +201,57 @@ export MONKEYSPHERE_USER
export KEYSERVER
export GNUPGHOME_HOST
export GNUPGHOME
+export HOST_FINGERPRINT
# get subcommand
COMMAND="$1"
[ "$COMMAND" ] || failure "Type '$PGRM help' for usage."
shift
+
case $COMMAND in
'show-key'|'show'|'s')
- check_host_keyring
+ check_host_fail
show_key
;;
- # FIXME: what should we call this command?
'set-expire'|'extend-key'|'e')
- check_host_keyring
- source "${MHSHAREDIR}/extend_key"
- extend_key "$@"
+ check_host_fail
+ source "${MHSHAREDIR}/set_expire"
+ set_expire "$@"
;;
'add-hostname'|'add-name'|'n+')
- check_host_keyring
+ check_host_fail
source "${MHSHAREDIR}/add_hostname"
add_hostname "$@"
;;
'revoke-hostname'|'revoke-name'|'n-')
- check_host_keyring
+ check_host_fail
source "${MHSHAREDIR}/revoke_hostname"
revoke_hostname "$@"
;;
'add-revoker'|'o')
- check_host_keyring
+ check_host_fail
source "${MHSHAREDIR}/add_revoker"
add_revoker "$@"
;;
'revoke-key'|'r')
- check_host_keyring
+ check_host_fail
source "${MHSHAREDIR}/revoke_key"
revoke_key "$@"
;;
'publish-key'|'publish'|'p')
- check_host_keyring
+ check_host_fail
source "${MHSHAREDIR}/publish_key"
publish_key
;;
- 'expert'|'e')
+ 'expert')
SUBCOMMAND="$1"
shift
case "$SUBCOMMAND" in